Module Chapter4
    '***************************************************************************
    'Listing 4.4
    Public Function MyFunctionA() As String
        MyFunctionA = "ReturnValue"
    End Function
    '***************************************************************************
    'Listing 4.5
    Public Function MyFunctionB() As String
        Return "ReturnValue"
    End Function
    '***************************************************************************
    'Listing 4.6
    Public Function MyFunctionC(ByVal SomeFlag As Boolean) As String
        MyFunctionC = "One Value" 'Set the default return value
        If SomeFlag Then
            MyFunctionC = "Another Value" 'Set the return value to a new value
        End If
    End Function
    '***************************************************************************
    'Listing 4.7
    Public Function MyFunctionD(ByVal SomeFlag As Boolean) As String
        Return "One Value" 'This will be the only code in the function that executes
        If SomeFlag Then
            Return "Another Value" 'This can never be executed
        End If
    End Function
    '***************************************************************************
    'Listing 4.12
    Public Function FunctionOne(ByVal companyName As String, ByVal companyID As Integer) As String
    End Function
    Public Function FunctionTwo(ByVal firstName As String, ByVal employeeID As Integer) As String
    End Function
    '***************************************************************************
    'Listing 4.13
    Public Overloads Function AddValues(ByVal Value1 As Integer, ByVal Value2 As Integer) As Integer
        Return Value1 + Value2
    End Function
    Public Overloads Function AddValues(ByVal Value1 As Integer, ByVal Value2 As Integer, ByVal Value3 As Integer) As Integer
        Return Value1 + Value2 + Value3
    End Function
    '***************************************************************************
    'Listing 4.16
    Public Property FirstName() As String
        Get
            Return c_sFirstName
        End Get
        Set(ByVal Value As String)
            c_sFirstName = Value
        End Set
    End Property
    '***************************************************************************
    'Listing 4.17
    Private c_sFirstName As String
    Public ReadOnly Property FirstName() As String
        Get
            Return c_sFirstName
        End Get
    End Property
    '***************************************************************************
    'Listing 4.18
    Private c_sFirstName As String
    Public WriteOnly Property FirstName() As String
        Set(ByVal Value As String)
            c_sFirstName = Value
        End Set
    End Property
    '***************************************************************************
    'Listing 4.19
    Default Public Property ChildrenNames(ByVal Index As Integer) As String
        Get
            Return m_sChildren(Index)
        End Get
        Set(ByVal Value As String)
            m_sChildren(Index) = Value
        End Set
    End Property
End Module
'***************************************************************************
' Listing 4.8, 4.20, 4.23
Public Class Employee
    Private Shared c_iEmployeeCount As Integer
    Private c_sFirstName As String
    Private c_iEmployeeID As Integer
    Private Sub New(ByVal EmployeeID As Integer)
        ' Get Employee Information from Database and store in member variables
        c_iEmployeeID = EmployeeID
    End Sub
    Public Property FirstName() As String
        Get
            FirstName = c_sFirstName
        End Get
        Set(ByVal Value As String)
            c_sFirstName = Value
        End Set
    End Property
    Public ReadOnly Property EmployeeID() As Integer
        Get
            EmployeeID = c_iEmployeeID
        End Get
    End Property

    ' Get Employee Count first time that it is needed
    Public Shared ReadOnly Property EmployeeCount() As Integer
        Get
            If c_iEmployeeCount = -1 Then
                'Get Employee Count from database and store in shared field
                c_iEmployeeCount = CountRetreivedFromDatabase
            End If
            Return c_iEmployeeCount
        End Get
    End Property


    'Following Sub is from previous example
    Public Shared Sub AddEmployee(ByVal FirstName As String, ByVal LastName As String, ByVal Department As String, ByVal SSN As String)
        ' Do some database access to store the new employee
        c_iEmployeeCount = c_iEmployeeCount + 1
    End Sub
End Class
'***************************************************************************
'Listing 4.24
' Declare the delegate this will define the function and the parameters and return type. Any function that has the same signature can be called by the delegate.
Delegate Function MyCompareDelegate(ByVal x As Integer, ByVal y As Integer) As Boolean
' Create code that will use the delegate to invoke a the function represented by the delegate
Sub MySub(ByVal MyDelegate As MyCompareDelegate)
    ' Call the function represented by the Delegate
    MyDelegate.Invoke(5, 3)
End Sub
' Create Functions that can be represented by the delegate
Function CompareLow(ByVal X As Integer, ByVal Y As Integer) As Boolean
    If X > Y Then
        Return True
    Else
        Return False
    End If
End Function
Function CompareHigh(ByVal X As Integer, ByVal Y As Integer) As Boolean
    If X < Y Then
        Return True
    Else
        Return False
    End If
End Function
' Code to call the functions through the Delegate
Sub Main()
    Call MySub(AddressOf Me.CompareLow)
    Call MySub(AddressOf Me.CompareHigh)
End Sub
'***************************************************************************
'Listing 4.27
Public Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows Forms.MouseEventArgs)
    'Note I added additional code to retrieve the parameters that were used in VB6
    Dim Button As system.Windows Forms.MouseButtons
    Dim X As Integer
    Dim Y As Integer
    Button = e.Button
    X = e.X
    Y = e.Y
End Sub
'***************************************************************************
'Listing 4.28
Protected Sub CommonEventHandler(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click, Button2.Click, Form1.Click
    If sender Is form1 Then
        msgbox("Form Clicked")
    Else
        msgbox(CType(sender, Button).text)
    End If
End Sub
'***************************************************************************
'Listing 4.34
Public Class MyMouseEventArgs
    Inherits System.EventArgs
    Public ReadOnly Property XPosition() As Integer
        Get
            Return Cursor.Position.X
        End Get
    End Property
    Public ReadOnly Property YPosition() As Integer
        Get
            Return Cursor.Position.Y
        End Get
    End Property
End Class
'***************************************************************************
'Listing 4.35
Public Event MouseOver(ByVal Sender As Object, ByVal e As System.EventArgs)
' Define a test subroutine to Raise the event
Public Sub TestRaiseEvent()
    RaiseEvent Ctype(MouseOver(Me, New MyMouseEventArgs()), System.EventArgs)
End Sub
' In a form class define a variable as the test event raiser
Private WithEvents MyEventObject As MyEventObjectTester
' In the form class define the event handler to handle the event raised from MyEventObject and the Form Click
Private Sub MyEventHandler(ByVal Sender As Object, ByVal e As System.EventArgs) Handles MyEventObject.MouseDown, Form1.Click
    Dim oMyMouseEventArgs As MyMouseEventArgs
    If Not Sender Is Form1 Then
        oMyMouseEventArgs = CType(e, MyMouseEventArgs)
        Console.WriteLine(e.XPosition.ToString())
        Console.WriteLine(e.YPosition.ToString())
    Else
        Console.WriteLine("Form Raised Click Event")
    End If
End Sub
'***************************************************************************
'Listing 4.37
<WebMethod()> _
Public Function GetEmployees() As DataSet
    Dim oDataSet As New DataSet()
    'Code to create a dataset
    Return oDataSet
End Function
'***************************************************************************
'Listing 4.40
<Bindable(True), Category("Dates"), DefaultValue("")> Property EndDate() As Date
    Get
        Return CType(State("EndDate"), Date)
    End Get
    Set(ByVal Value As Date)
        c_dteEndDate = Value
        State("EndDate") = Value
        If c_dteStartDate < c_dteEndDate Then
            CreateTimeTable()
        End If
    End Set
End Property
'***************************************************************************
'Listing 4.41
Declare Auto Sub CopyFile Lib "Kernel32" (ByVal <MarshalAs(UnmanagedType.LPTStr)> existingfile As String, ByVal <MarshalAs(UnmanagedType.LPTStr)> newfile As String, ByVal failifexists As Boolean)