Imports System.ComponentModel
Imports System
Imports System.IO
Imports System.Reflection
Imports System.EnterpriseServices
Imports CRM = System.EnterpriseServices.CompensatingResourceManager

<Assembly: ApplicationName("CRMCompensationManager")> 
<Assembly: ApplicationActivation(ActivationOption.Server)> 
<Assembly: CRM.ApplicationCrmEnabled()> 
<Assembly: AssemblyKeyFile("StrongName.snk")> 



<TransactionAttribute()> _
Public Class TestWorker
    Inherits ServicedComponent
    Private c_clerk As CRM.Clerk
    Public Sub New()
        c_clerk = New CRM.Clerk(GetType(CRMCompensator), ".NET CRM  Sample", CRM.CompensatorOptions.AllPhases)
    End Sub
    Public Sub DeleteFile(ByVal msg As String)
        If System.IO.File.Exists(msg & ".crmTmp") Then
            c_clerk.ForceTransactionToAbort()
        Else
            c_clerk.WriteLogRecord(msg)
            c_clerk.ForceLog()
            Try
                File.Move(msg, msg & ".crmTmp")
            Catch
                c_clerk.ForceTransactionToAbort()
            End Try
        End If
    End Sub
    Public Sub Commit()
        ContextUtil.SetComplete()
    End Sub
    Public Sub Abort()
        ContextUtil.SetAbort()
    End Sub
End Class

Public Class CRMCompensator
    Inherits CRM.Compensator

    Public Overrides Function CommitRecord(ByVal rec As CRM.LogRecord) As Boolean
        'delete file
        Try
            System.IO.File.Delete(rec.Record & ".crmTmp")
            MsgBox("Deleted", rec.Record & ".crmTmp")
        Catch
            MsgBox("Could not deleted", rec.Record & ".crmTmp")
        End Try

        Return False

    End Function

    Public Overrides Function AbortRecord(ByVal rec As CRM.LogRecord) As Boolean
        ' do something here - undelete file
        Try
            System.IO.File.Move(rec.Record+".crmTmp", CTYPE(rec.Record,String)
            MsgBox("Aborting delete", CTYPE(rec.Record,String)      
        Catch
            MsgBox("Could not abort delete", CTYPE(rec.Record,String)
        End Try

        Return False

    End Function


End Class
